<!DOCTYPE html>
<html lang="en" xmlns="http://www.w3.org/1999/xhtml"
        xmlns:h="http://xmlns.jcp.org/jsf/html"
        xmlns:f="http://xmlns.jcp.org/jsf/core"
        xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
        xmlns:p="http://xmlns.jcp.org/jsf/passthrough">

    <h:body role="document">
        <ui:composition template="../templates/main.xhtml">

            <ui:define name="metadata">
                <f:metadata>
                    <f:viewParam name="id" value="#{harvesterAction.id}" />
                    <f:viewAction action="#{harvesterAction.load}" />
                </f:metadata>
            </ui:define>

            <ui:define name="title">${localized[harvester.id eq null ? 'buttonHarvesterNew' : "titleHarvesterEdit"]}</ui:define>

            <ui:define name="content">
                <div class="page-header">
                    <h1>
                        <ui:fragment rendered="${harvester.id eq null}">
                            ${localized.titleHarvesterSingular}
                            <span class="label label-success">${localized.buttonMiscNew}</span>
                        </ui:fragment>
                        <ui:fragment rendered="${harvester.id ne null}">
                            ${harvesterAction.harvester.name}
                            <small>${localized.titleHarvesterSingular}</small>
                        </ui:fragment>
                    </h1>
                </div>

                <div class="row">
                    <div class="col-md-8">
                        <h:form styleClass="form-horizontal" id="formHarvesterEdit">

                            <h:messages styleClass="list-unstyled"
                                        errorClass="alert alert-danger" infoClass="alert alert-success"
                                        warnClass="alert alert-warning" p:role="alert" />

                            <!-- Nav tabs -->
                            <ul class="nav nav-tabs" role="tablist">
                                <li role="presentation" class="active">
                                    <a href="#general" id="panelHeaderGeneral" aria-controls="general" role="tab" data-toggle="tab">${localized.labelMiscGeneral}</a>
                                </li>
                                <li role="presentation">
                                    <a href="#repositories" id="panelHeaderRepository" aria-controls="repositories" role="tab" data-toggle="tab">${localized.titleRepositoryPlural}</a>
                                </li>
                                <li role="presentation">
                                    <a href="#schedule" id="panelHeaderFrequency" aria-controls="schedule" role="tab" data-toggle="tab">${localized.labelHarvesterSchedule}</a>
                                </li>
                                <li role="presentation">
                                    <a href="#filter" id="panelHeaderFilter" aria-controls="filter" role="tab" data-toggle="tab">${localized.labelHarvesterFilter}</a>
                                </li>
                                <li role="presentation">
                                    <a href="#transformation" id="panelHeaderTransformation" aria-controls="transformation" role="tab" data-toggle="tab">${localized.labelHarvesterTransformation}</a>
                                </li>
                            </ul>

                            <!-- Tab panes -->
                            <div class="tab-content">
                                <div role="tabpanel" class="tab-pane fade in active" id="general">
                                    <p />
                                    <div class="form-group">
                                        <label for="inputName" class="col-sm-3 control-label">${localized.inputMiscName}</label>
                                        <div class="col-sm-9">
                                            <h:inputText value="#{harvester.name}"
                                                         p:placeholder="${localized.inputMiscName}" required="true"
                                                         requiredMessage="${localized.msgErrNameRequired}"
                                                         styleClass="form-control" p:type="text" id="inputName" />
                                        </div>
                                    </div>
                                    <div class="form-group">
                                        <label for="inputDescription" class="col-sm-3 control-label">${localized.inputMiscDescription}</label>
                                        <div class="col-sm-9">
                                            <h:inputTextarea
                                                    value="#{harvester.description}"
                                                    required="false" styleClass="form-control"
                                                    id="inputDescription" />
                                        </div>
                                    </div>
                                    <div class="form-group">
                                        <label for="inputVisibility" class="col-sm-3 control-label">${localized.visibility}</label>
                                        <div class="col-sm-9">
                                            <h:selectOneRadio
                                                    styleClass="inlineRadioButtons table-condensed"
                                                    value="#{harvester.visibility}"
                                                    id="inputVisibility">
                                                <f:selectItems value="#{repositoryAction.visibilities}"
                                                               var="visibility" itemValue="#{visibility}"
                                                               itemLabel="${localized['visibility' += visibility.label]}" />
                                            </h:selectOneRadio>
                                        </div>
                                    </div>
                                    <div class="form-group">
                                        <label for="inputHarvesterEmailNotification"
                                               class="col-sm-3 control-label">${localized.inputHarvesterEmailNotification}</label>
                                        <div class="col-sm-9">
                                            <div class="checkbox">
                                                <label> <h:selectBooleanCheckbox
                                                        value="#{harvester.emailNotification}"
                                                        p:type="checkbox" id="inputHarvesterEmailNotification" />
                                                </label>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="form-group">
                                        <label for="inputForceUpdate"
                                               class="col-sm-3 control-label">${localized.inputHarvesterForceUpdate}</label>
                                        <div class="col-sm-9">
                                            <div class="checkbox">
                                                <label> <h:selectBooleanCheckbox
                                                        value="#{harvester.forceUpdate}"
                                                        p:type="checkbox" id="inputForceUpdate" />
                                                </label>
                                            </div>
                                        </div>
                                    </div>
                                </div>

                                <div role="tabpanel" class="tab-pane fade" id="repositories">
                                    <h2>${localized.labelHarvesterSourceRepo}</h2>
                                    <div class="panel panel-default">
                                        <div class="panel-body">
                                            <div class="form-group">
                                                <label for="selectSourceRepository"
                                                       class="col-sm-3 control-label">${localized.inputHarvesterSelectRepository}</label>
                                                <div class="col-sm-9">
                                                    <h:selectOneMenu id="selectSourceRepository"
                                                                     styleClass="form-control"
                                                                     value="#{harvester.source}"
                                                                     converter="#{repositoryConverter}" >
                                                        <f:selectItem noSelectionOption="true" itemDisabled="true"
                                                                      itemLabel="${localized.labelMiscSelect}" />
                                                        <f:selectItems styleClass="form-control"
                                                                value="${repositoryController.allRepositories}"
                                                                var="repository" itemValue="#{repository}"
                                                                itemLabel="${repository.name}" />
                                                        <f:ajax render="sourceRepoInfo" />
                                                    </h:selectOneMenu>
                                                </div>
                                            </div>
                                            <h:panelGroup id="sourceRepoInfo">
                                                <div class="form-group">
                                                    <div class="col-sm-offset-3 col-sm-6">
                                                        <h:outputText styleClass="form-control-static"
                                                                      value="${localized.inputMiscUrl}: ${harvester.source.url}"
                                                                      id="sourceRepositoryUrl" />
                                                    </div>
                                                    <div class="col-sm-3 text-right">
                                                        <h:outputText styleClass="form-control-static"
                                                                      value="${localized.inputRepositoryType}: ${harvester.source.repositoryType.label}"
                                                                      id="sourceRepositoryType" />
                                                    </div>
                                                </div>
                                                <ui:fragment id="sourceApiKey"
                                                             rendered="${harvester.source.repositoryType.requiresApiKey}">
                                                    <div class="form-group">
                                                        <label class="col-sm-3 control-label">${localized.inputRepositoryApiKey}</label>
                                                        <div class="col-sm-9">
                                                            <h:inputText id="inputSourceApiKey"
                                                                         value="#{harvester.sourceApiKey}"
                                                                         styleClass="form-control" />
                                                        </div>
                                                    </div>
                                                </ui:fragment>
                                            </h:panelGroup>
                                        </div>
                                    </div>
                                    <h2>${localized.labelHarvesterTargetRepo}</h2>
                                    <div class="panel panel-default">
                                        <div class="panel-body">
                                            <div class="form-group">
                                                <label for="selectTargetRepository"
                                                       class="col-sm-3 control-label">${localized.inputHarvesterSelectRepository}</label>
                                                <div class="col-sm-9">
                                                    <h:selectOneMenu id="selectTargetRepository"
                                                                     styleClass="form-control"
                                                                     value="#{harvester.target}"
                                                                     converter="#{repositoryConverter}">
                                                        <f:selectItem noSelectionOption="true" itemDisabled="true"
                                                                      itemLabel="${localized.labelMiscSelect}" />
                                                        <f:selectItems styleClass="form-control"
                                                                       value="${repositoryController.allRepositories}"
                                                                       var="repository" itemValue="#{repository}"
                                                                       itemLabel="${repository.name}" />
                                                        <f:ajax render="targetRepoInfo" />
                                                    </h:selectOneMenu>
                                                </div>
                                            </div>
                                            <h:panelGroup id="targetRepoInfo">
                                                <div class="form-group">
                                                    <div class="col-sm-offset-3 col-sm-6">
                                                        <h:outputText styleClass="form-control-static"
                                                                      value="${localized.inputMiscUrl}: ${harvester.target.url}"
                                                                      id="targetRepositoryUrl" />
                                                    </div>
                                                    <div class="col-sm-3 text-right">
                                                        <h:outputText styleClass="form-control-static"
                                                                      value="${localized.inputRepositoryType}: ${harvester.target.repositoryType.label}"
                                                                      id="targetRepositoryType" />
                                                    </div>
                                                </div>
                                                <ui:fragment id="targetApiKey"
                                                             rendered="${harvester.target.repositoryType.requiresApiKey}">
                                                    <div class="form-group">
                                                        <label for="inputApiKey" class="col-sm-3 control-label">${localized.inputRepositoryApiKey}</label>
                                                        <div class="col-sm-9">
                                                            <h:inputText id="inputApiKey"
                                                                         value="#{harvester.targetApiKey}"
                                                                         styleClass="form-control" />
                                                        </div>
                                                    </div>
                                                </ui:fragment>
                                            </h:panelGroup>
                                        </div>
                                    </div>
                                </div>

                                <div role="tabpanel" class="tab-pane fade in" id="schedule">
                                    <p />
                                    <div class="form-group">
                                        <label for="inputHarvestFrequency"
                                               class="col-sm-3 control-label">${localized.harvestFrequency}</label>
                                        <div class="col-sm-9">
                                            <h:selectOneMenu styleClass="form-control"
                                                             value="#{harvester.frequency}"
                                                             id="inputHarvestFrequency" required="true"
                                                             requiredMessage="${localized.msgErrScheduleRequired}">
                                                <f:selectItem noSelectionOption="true" itemDisabled="true"
                                                              itemLabel="${localized.labelMiscSelect}" />
                                                <f:selectItems value="#{harvesterController.frequencies}"
                                                               var="frequency" itemValue="#{frequency}"
                                                               itemLabel="${localized['harvestFrequency' += frequency.label]}" />
                                                <f:ajax render="firstHarvestDate" />
                                            </h:selectOneMenu>
                                        </div>
                                    </div>
                                    <h:panelGroup id="firstHarvestDate">
                                        <ui:fragment
                                                rendered="${not empty harvester.frequency and harvester.frequency != 'manually'}">
                                            <div class="form-group">
                                                <label for="inputHarvestDate" class="col-sm-3 control-label">${localized.inputHarvesterDate}</label>
                                                <div class="col-sm-9">
                                                    <div class="input-group date" id="datetimepicker">
													<span class="input-group-addon"> <span class="glyphicon glyphicon-calendar" />
													</span>
                                                        <h:inputText
                                                                value="#{harvester.nextHarvestDate}"
                                                                styleClass="form-control" id="inputHarvestDate">
                                                            <f:convertDateTime type="both" dateStyle="short"
                                                                               timeZone="${appLocalization.timeZone}"
                                                                               locale="#{appLocalization.localeCode}" />
                                                        </h:inputText>
                                                    </div>
                                                </div>
                                            </div>
                                            <script type="text/javascript">
                                                $(function () {
                                                    $("#datetimepicker").datetimepicker({
                                                        locale: "${appLocalization.localeCode}",
                                                        format: "L LTS"
                                                    });
                                                });
                                            </script>
                                        </ui:fragment>
                                    </h:panelGroup>
                                </div>

                                <div role="tabpanel" class="tab-pane fade" id="filter">
                                    <h:panelGroup id="filterList" rendered="${harvester.source.repositoryType.label eq 'CKAN' || harvester.source.repositoryType.label eq 'OpenDataSoft'}">
                                        <p />
                                        <ui:repeat var="filter" value="${harvesterAction.filters}" varStatus="filterStatus">
                                            <div class="form-group" id="filterVar">
                                                <div class="col-sm-4">
                                                    <div class="input-group">
                                                        <span class="input-group-btn">
                                                            <h:commandLink
                                                                action="#{filter.setNegation(!filter.negation)}"
                                                                styleClass="btn btn-default"
                                                                value="${filter.negation ? 'N' : 'P'}"
                                                                id="inputFilterNegate">
                              									<f:ajax render="@this" />
                              								</h:commandLink>
                                                        </span>
                                                        <h:inputText value="#{filter.attribute}" styleClass="form-control" p:placeholder="Field" id="inputFilterAttribute">
                                                            <f:ajax />
                                                        </h:inputText>
                                                    </div>
                                                </div>
                                                <div class="col-sm-6">
                                                    <h:inputText value="#{filter.value}" styleClass="form-control" p:placeholder="Value" id="inputFilterValue">
                                                        <f:ajax />
                                                    </h:inputText>
                                                </div>
                                                <div class="col-sm-2 text-right">
                                                    <h:commandLink
                                                            action="#{filter.setFilterEnabled(!filter.filterEnabled)}"
                                                            styleClass="btn btn-default" id="inputFilterEnable">
													    <span class="glyphicon ${filter.filterEnabled ? 'glyphicon-check' : 'glyphicon-unchecked'}" />
                                                        <f:ajax render="@this" />
                                                    </h:commandLink>
                                                    <h:commandLink
                                                            action="#{harvesterAction.removeFilter(filter)}"
                                                            styleClass="btn btn-danger" id="inputFilterRemove">
                                                        <span class="glyphicon glyphicon-trash" />
                                                        <f:ajax render="${component.parent.parent.clientId}" />
                                                    </h:commandLink>
                                                </div>
                                            </div>
                                            <div class="form-group">
                                                <div class="col-sm-12 text-center">
                                                    <h:commandLink rendered="#{!filterStatus.last}"
                                                                   action="#{filter.setAndOp(!filter.andOp)}"
                                                                   value="${filter.andOp ? 'AND' : 'OR'}">
                                                        <f:ajax render="@this" />
                                                    </h:commandLink>
                                                </div>
                                            </div>
                                        </ui:repeat>
                                    </h:panelGroup>
                                    <h:commandButton action="#{harvesterAction.addFilter()}" id="buttonFilterAdd"
                                                     value="${localized.buttonMiscAdd}" styleClass="btn btn-success"
                                                     rendered="${harvester.source.repositoryType.label eq 'CKAN' || harvester.source.repositoryType.label eq 'OpenDataSoft'}">
                                        <f:ajax render="filterList" />
                                    </h:commandButton>
                                    <p />
                                    <ui:fragment rendered="${!(harvester.source.repositoryType.label eq 'CKAN' || harvester.source.repositoryType.label eq 'OpenDataSoft')}">
                                        <div class="alert alert-info">${localized.msgInfoFilterNotSupported}</div>
                                    </ui:fragment>
                                </div>

                                <div role="tabpanel" class="tab-pane fade" id="transformation">

                                    <h:panelGroup>
                                        <p />
                                        <div class="form-group">
                                            <label for="inputRadioScriptSource" class="col-sm-3 control-label">${localized.transformationScriptSource}</label>
                                            <div class="col-sm-9">
                                                <h:selectOneRadio id="inputRadioScriptSource"
                                                                  styleClass="inlineRadioButtons table-condensed from-control"
                                                                  value="${harvester.transformationScriptSource}"
                                                                  required="true"
                                                                  requiredMessage="${localized.msgErrScriptSourceRequired}">
                                                    <f:selectItems styleClass="form-control"
                                                                   value="#{harvesterAction.transformationScriptSources}"
                                                                   var="transformationScriptSource"
                                                                   itemValue="#{transformationScriptSource}"
                                                                   itemLabel="${localized['transformationScriptSource' += transformationScriptSource.label]}" />
                                                    <f:ajax render="git custom" />
                                                </h:selectOneRadio>
                                            </div>
                                        </div>
                                    </h:panelGroup>

                                    <h:panelGroup id="git">
                                        <ui:fragment rendered="${harvester.transformationScriptSource eq 'git'}">
                                            <p />
                                            <div class="form-group">
                                                <label for="gitRepoUrl" class="col-sm-3 control-label">${localized.inputMiscUrl}</label>
                                                <div class="col-sm-9">
                                                    <h:inputText id="gitRepoUrl"
                                                                 value="#{harvester.gitRepoUrl}"
                                                                 p:placeholder="https://example.com/sample.git"
                                                                 required="#{harvester.transformationScriptSource eq 'git'}"
                                                                 requiredMessage="${localized.msgErrUrlRequired}"
                                                                 styleClass="form-control" />
                                                </div>
                                            </div>
                                            <div class="form-group">
                                                <label for="gitBranch" class="col-sm-3 control-label">${localized.inputGitBranch}</label>
                                                <div class="col-sm-9">
                                                    <h:inputText id="gitBranch"
                                                                 value="#{harvester.gitBranch}"
                                                                 p:placeholder="master"
                                                                 required="#{harvester.transformationScriptSource eq 'git'}"
                                                                 requiredMessage="${localized.msgErrBranchRequired}"
                                                                 styleClass="form-control" />
                                                </div>
                                            </div>
                                            <div class="form-group">
                                                <label for="inputRequiresCredentials"
                                                       class="col-sm-3 control-label">${localized.inputGitRequiresCredentials}</label>
                                                <div class="col-sm-1">
                                                    <div class="checkbox">
                                                        <label> <h:selectBooleanCheckbox
                                                                id="inputRequiresCredentials"
                                                                value="#{harvester.gitRepoRequiresCredentials}">
                                                            <f:ajax render="gitCredentials" />
                                                        </h:selectBooleanCheckbox>
                                                        </label>
                                                    </div>
                                                </div>
                                                <label for="inputSshAuth"
                                                       class="col-sm-3 control-label">${localized.inputGitSshAuth}</label>
                                                <div class="col-sm-1">
                                                    <div class="checkbox">
                                                        <label> <h:selectBooleanCheckbox
                                                                id="inputSshAuth"
                                                                value="#{harvester.gitRepoSshAuthentication}">
                                                            <f:ajax render="gitCredentials" />
                                                        </h:selectBooleanCheckbox>
                                                        </label>
                                                    </div>
                                                </div>
                                            </div>
                                            <h:panelGroup id="gitCredentials">
                                                <ui:fragment rendered="${harvester.gitRepoRequiresCredentials and
                                                                         !harvester.gitRepoSshAuthentication}">
                                                    <div class="form-group">
                                                        <label for="inputUserName" class="col-sm-3 control-label">${localized.inputMiscName}</label>
                                                        <div class="col-sm-9">
                                                            <h:inputText id="inputUserName"
                                                                         value="#{harvester.gitUserName}"
                                                                         p:placeholder="${localized.inputUsername}"
                                                                         required="#{harvester.gitRepoRequiresCredentials and !harvester.gitRepoSshAuthentication}"
                                                                         requiredMessage="${localized.msgErrInvalidGitCredentials}"
                                                                         styleClass="form-control" />
                                                        </div>
                                                    </div>
                                                </ui:fragment>
                                                <ui:fragment rendered="${harvester.gitRepoRequiresCredentials}">
                                                    <div class="form-group">
                                                        <label for="inputPassword" class="col-sm-3 control-label">${localized.inputMiscPassword}</label>
                                                        <div class="col-sm-9">
                                                            <h:inputSecret id="inputPassword"
                                                                           value="#{harvester.gitPassWord}"
                                                                           redisplay="true"
                                                                           p:placeholder="${localized.inputPassword}"
                                                                           required="#{harvester.gitRepoRequiresCredentials}"
                                                                           requiredMessage="${localized.msgErrInvalidGitCredentials}"
                                                                           styleClass="form-control" />
                                                        </div>
                                                    </div>
                                                </ui:fragment>
                                            </h:panelGroup>
                                            <div class="form-group">
                                                <div class="col-sm-offset-3 col-sm-2">
                                                    <h:commandButton value="${localized.buttonGitFetch  }"
                                                                     action="#{harvesterAction.fetchGitRepository()}"
                                                                     styleClass="btn btn-primary" id="inputGitFetch">
                                                        <f:ajax execute="@form" render="selectScriptFile"/>
                                                    </h:commandButton>
                                                </div>
                                            </div>
                                            <div class="form-group">
                                                <label for="selectScriptFile" class="col-sm-3 control-label">${localized.inputGitRepoFile}</label>
                                                <div class="col-sm-9">
                                                    <h:selectOneMenu id="selectScriptFile"
                                                                     styleClass="form-control"
                                                                     value="#{harvester.gitFileName}">
                                                        <f:selectItem noSelectionOption="true" itemDisabled="true"
                                                                      itemLabel="${localized.labelMiscSelect}" />
                                                        <f:selectItems value="#{harvesterAction.listAllScripts()}"
                                                                       var="gitFileName" itemValue="#{gitFileName}"
                                                                       itemLabel="${gitFileName}"
                                                                       styleClass="form-control" />
                                                    </h:selectOneMenu>
                                                </div>
                                            </div>
                                        </ui:fragment>
                                    </h:panelGroup>

                                    <script src="https://cdnjs.cloudflare.com/ajax/libs/ace/1.2.0/ace.js" />
                                    <h:panelGroup id="custom">
                                        <ui:fragment rendered="${harvester.transformationScriptSource eq 'custom'}">
                                            <p />
                                            <ui:fragment rendered="${empty harvester.mappingScript}">
                                                <div class="alert alert-info">${localized.infoHintHarvesterExampleScript}</div>
                                            </ui:fragment>
                                            <div id="textarea">
                                                <h:inputTextarea styleClass="form-control" id="inputScriptText" value="#{harvester.mappingScript}" />
                                                <pre id="editor" style="height: 600px;" />
                                                <script>
                                                    var textarea = $("#textarea textarea").hide();
                                                    var editor = ace.edit("editor");
                                                    editor.setTheme("ace/theme/tomorrow_night_blue");
                                                    editor.getSession().setMode("ace/mode/javascript");
                                                    editor.getSession().setValue(textarea.val());
                                                    editor.getSession().on('change', function () {
                                                        textarea.val(editor.getSession().getValue());
                                                    });
                                                </script>
                                            </div>
                                        </ui:fragment>
                                    </h:panelGroup>
                                </div>
                                <hr />
                                <div class="form-group">
                                    <div class="col-sm-2">
                                        <h:commandButton value="${harvester.id eq null ? localized.buttonMiscCreate : localized.buttonMiscApply}"
                                                         action="#{harvesterAction.save}"
                                                         styleClass="btn btn-primary" id="buttonCreate"/>
                                    </div>
                                    <h:panelGroup rendered="${harvester.id ne null}">
                                        <div class="col-sm-2">
                                            <h:commandButton value="${localized.buttonMiscDelete}"
                                                             action="#{harvesterAction.delete}"
                                                             styleClass="btn btn-danger" id="buttonDelete"/>
                                        </div>
                                        <div class="col-sm-2">
                                            <h:link outcome="/public/showharvester?faces-redirect=true" styleClass="btn btn-info" id="buttonView">
                                                <f:param name="id" value="#{harvester.id}" />
                                                <span class="glyphicon glyphicon-eye-open" />
                                            </h:link>
                                        </div>
                                    </h:panelGroup>
                                </div>
                            </div>
                        </h:form>
                    </div>

                    <div class="col-md-4">
                        <div class="panel panel-info">
                            <div class="panel-heading">${localized.infoMiscPanelHeaderInformation}</div>
                            <div class="panel-body">
                                <h:outputText value="${localized.infoPanelHarvester}" escape="false" />
                            </div>
                        </div>
                    </div>
                </div>
            </ui:define>
        </ui:composition>
    </h:body>
</html>